* *********************************************************
* *
* * 12/11/07               PLAN.DBC               13:56:03
* *
* *********************************************************
* *
* * Description:
* * This program was automatically generated by GENDBC
* * Version 2.26.67
* *
* *********************************************************


DisplayStatus([Creating database...])
CLOSE DATA ALL
CREATE DATABASE 'PLAN.DBC'
DisplayStatus([Creating table TOVARY...])
MakeTable_TOVARY()
DisplayStatus([Creating table MATERIALY...])
MakeTable_MATERIALY()
DisplayStatus([Creating table SPECIFICATION...])
MakeTable_SPECIFICATION()
DisplayStatus([Creating table PLAN_TOV...])
MakeTable_PLAN_TOV()
DisplayStatus([Creating table CONT_PLAN...])
MakeTable_CONT_PLAN()
DisplayStatus([Creating persistent relations...])
MakeRelation_1()
MakeRelation_2()
MakeRelation_3()
MakeRelation_4()
DisplayStatus([Creating relational integrity rules...])
MakeRI()
DisplayStatus([Finished.])


********* Procedure Re-Creation *********
IF !FILE([PLAN.krt])
    ? [Warning! No Procedure File Found!]
ELSE
	CLOSE DATABASE
	USE 'PLAN.DBC'
	g_SetSafety = SET('SAFETY')
	SET SAFETY OFF
	LOCATE FOR Objectname = 'StoredProceduresSource'
	IF FOUND()
        APPEND MEMO Code FROM [PLAN.krt] OVERWRITE
	    REPLACE Code WITH SUBSTR(Code, 70, 32795)
	ENDIF
	LOCATE FOR Objectname = 'StoredProceduresObject'
	IF FOUND()
        APPEND MEMO Code FROM [PLAN.krt] OVERWRITE
        REPLACE Code WITH SUBSTR(Code, 32865)
	ENDIF
    SET SAFETY &g_SetSafety
	USE
	OPEN DATABASE [PLAN.DBC]
ENDIF

FUNCTION MakeTable_TOVARY
***** Table setup for TOVARY *****
CREATE TABLE 'TOVARY.DBF' NAME 'TOVARY' (ID_TOV I NOT NULL AUTOINC NEXTVALUE 2 STEP 1, ;
                     NAIMEN C(50) NOT NULL, ;
                     KOL_VO_CLC N(12, 3) NOT NULL, ;
                     ED_IZM C(10) NOT NULL, ;
                     COMMENT M NOCPTRANS NOT NULL)

***** Create each index for TOVARY *****
ALTER TABLE 'TOVARY' ADD PRIMARY KEY ID_TOV TAG ID_TOV COLLATE 'MACHINE'

***** Change properties for TOVARY *****
DBSETPROP('TOVARY.KOL_VO_CLC', 'Field', 'Comment', "   " + CHR(13) + "")
CREATE TRIGGER ON 'TOVARY' FOR DELETE AS __ri_delete_tovary()
CREATE TRIGGER ON 'TOVARY' FOR UPDATE AS __ri_update_tovary()
ENDFUNC

FUNCTION MakeTable_MATERIALY
***** Table setup for MATERIALY *****
CREATE TABLE 'MATERIALY.DBF' NAME 'MATERIALY' (ID_M I NOT NULL AUTOINC NEXTVALUE 1 STEP 1, ;
                        NAIMEN C(50) NOT NULL)

***** Create each index for MATERIALY *****
ALTER TABLE 'MATERIALY' ADD PRIMARY KEY ID_M TAG ID_M COLLATE 'MACHINE'

***** Change properties for MATERIALY *****
CREATE TRIGGER ON 'MATERIALY' FOR DELETE AS __ri_delete_materialy()
ENDFUNC

FUNCTION MakeTable_SPECIFICATION
***** Table setup for SPECIFICATION *****
CREATE TABLE 'SPECIFICATION.DBF' NAME 'SPECIFICATION' (ID_STR I NOT NULL AUTOINC NEXTVALUE 1 STEP 1, ;
                            ID_TOV I NOT NULL DEFAULT def_key("id_tov","tovary"), ;
                            ID_M I NOT NULL DEFAULT def_key("id_m","materialy"), ;
                            KOL_VO N(12, 3) NOT NULL)

***** Create each index for SPECIFICATION *****
ALTER TABLE 'SPECIFICATION' ADD PRIMARY KEY ID_STR TAG ID_STR COLLATE 'MACHINE'
INDEX ON ID_TOV TAG ID_TOV COLLATE 'MACHINE'
INDEX ON ID_M TAG ID_M COLLATE 'MACHINE'

***** Change properties for SPECIFICATION *****
CREATE TRIGGER ON 'SPECIFICATION' FOR INSERT AS __ri_insert_specification()
CREATE TRIGGER ON 'SPECIFICATION' FOR UPDATE AS __ri_update_specification()
ENDFUNC

FUNCTION MakeTable_PLAN_TOV
***** Table setup for PLAN_TOV *****
CREATE TABLE 'PLAN_TOV.DBF' NAME 'PLAN_TOV' (ID_PL I NOT NULL AUTOINC NEXTVALUE 1 STEP 1, ;
                       DT D NOT NULL, ;
                       COMMENT M NOT NULL)

***** Create each index for PLAN_TOV *****
ALTER TABLE 'PLAN_TOV' ADD PRIMARY KEY ID_PL TAG ID_PL COLLATE 'MACHINE'

***** Change properties for PLAN_TOV *****
CREATE TRIGGER ON 'PLAN_TOV' FOR DELETE AS __ri_delete_plan_tov()
CREATE TRIGGER ON 'PLAN_TOV' FOR UPDATE AS __ri_update_plan_tov()
ENDFUNC

FUNCTION MakeTable_CONT_PLAN
***** Table setup for CONT_PLAN *****
CREATE TABLE 'CONT_PLAN.DBF' NAME 'CONT_PLAN' (ID_STR I NOT NULL AUTOINC NEXTVALUE 1 STEP 1, ;
                        ID_PL I NOT NULL DEFAULT def_key("id_pl","plan_tov"), ;
                        ID_TOV I NOT NULL DEFAULT def_key("id_tov","tovary"), ;
                        KOL_VO N(12, 3) NOT NULL)

***** Create each index for CONT_PLAN *****
ALTER TABLE 'CONT_PLAN' ADD PRIMARY KEY ID_STR TAG ID_STR COLLATE 'MACHINE'
INDEX ON ID_PL TAG ID_PL COLLATE 'MACHINE'
INDEX ON ID_TOV TAG ID_TOV COLLATE 'MACHINE'

***** Change properties for CONT_PLAN *****
CREATE TRIGGER ON 'CONT_PLAN' FOR INSERT AS __ri_insert_cont_plan()
CREATE TRIGGER ON 'CONT_PLAN' FOR UPDATE AS __ri_update_cont_plan()
ENDFUNC

*************** Begin Relations Setup **************

FUNCTION MakeRelation_1
ALTER TABLE 'SPECIFICATION' ADD FOREIGN KEY TAG ID_M REFERENCES MATERIALY TAG ID_M
ENDFUNC


FUNCTION MakeRelation_2
ALTER TABLE 'CONT_PLAN' ADD FOREIGN KEY TAG ID_PL REFERENCES PLAN_TOV TAG ID_PL
ENDFUNC


FUNCTION MakeRelation_3
ALTER TABLE 'CONT_PLAN' ADD FOREIGN KEY TAG ID_TOV REFERENCES TOVARY TAG ID_TOV
ENDFUNC


FUNCTION MakeRelation_4
ALTER TABLE 'SPECIFICATION' ADD FOREIGN KEY TAG ID_TOV REFERENCES TOVARY TAG ID_TOV
ENDFUNC

FUNCTION MakeRI
***** Referential Integrity Setup *****
CLOSE DATABASE
USE 'PLAN.DBC'
LOCATE FOR ObjectType = 'Table' AND ObjectName = 'specification'
IF FOUND()
    nObjectID = ObjectID
    LOCATE FOR ObjectType = 'Relation' AND 'id_m'$Property AND 'materialy'$Property AND 'id_m'$Property AND ParentID = nObjectID
    IF FOUND()
	      REPLACE RiInfo WITH 'IRR   '
    ELSE
       ? "Could not set RI Information."
    ENDIF
ENDIF
LOCATE FOR ObjectType = 'Table' AND ObjectName = 'cont_plan'
IF FOUND()
    nObjectID = ObjectID
    LOCATE FOR ObjectType = 'Relation' AND 'id_pl'$Property AND 'plan_tov'$Property AND 'id_pl'$Property AND ParentID = nObjectID
    IF FOUND()
	      REPLACE RiInfo WITH 'RRR   '
    ELSE
       ? "Could not set RI Information."
    ENDIF
ENDIF
USE
ENDFUNC


FUNCTION DisplayStatus(lcMessage)
WAIT WINDOW NOWAIT lcMessage
ENDFUNC
